<?php
{{License}}
/**
 * {{EntityLabel}} file field renderer helper
 *
 * @category	{{Namespace}}
 * @package		{{Namespace}}_{{Module}}
 * {{qwertyuiop}}
 */
class {{Namespace}}_{{Module}}_Block_Adminhtml_{{Entity}}_Helper_File extends Varien_Data_Form_Element_Abstract{
	/**
	 * constructor
	 * @access public
	 * @param array $data
	 * @return void
	 * {{qwertyuiop}}
	 */
	public function __construct($data){
		parent::__construct($data);
		$this->setType('file');
	}
	/**
	 * get element html
	 * @access public
	 * @return string
	 * {{qwertyuiop}}
	 */
	public function getElementHtml(){
		$html = '';
		$this->setClass('input-file');
		$html.= parent::getElementHtml();
		if ($this->getValue()) {
			$url = $this->_getUrl();
			if( !preg_match("/^http\:\/\/|https\:\/\//", $url) ) {
				$url = Mage::helper('{{module}}/{{entity}}')->getFileBaseUrl() . $url;
			}
			$html .= '<br /><a href="'.$url.'">'.$this->_getUrl().'</a> ';
		}
		$html.= $this->_getDeleteCheckbox();
		return $html;
	}
	/**
	 * get the delete checkbox HTML
	 * @access protected
	 * @return string
	 * {{qwertyuiop}}
	 */
	protected function _getDeleteCheckbox(){
		$html = '';
		if ($this->getValue()) {
			$label = Mage::helper('{{module}}')->__('Delete File');
			$html .= '<span class="delete-image">';
			$html .= '<input type="checkbox" name="'.parent::getName().'[delete]" value="1" class="checkbox" id="'.$this->getHtmlId().'_delete"'.($this->getDisabled() ? ' disabled="disabled"': '').'/>';
			$html .= '<label for="'.$this->getHtmlId().'_delete"'.($this->getDisabled() ? ' class="disabled"' : '').'> '.$label.'</label>';
			$html .= $this->_getHiddenInput();
			$html .= '</span>';
		}		
		return $html;
	}
	/**
	 * get the hidden input
	 * @access protected
	 * @return string
	 * {{qwertyuiop}}
	 */
	protected function _getHiddenInput(){
		return '<input type="hidden" name="'.parent::getName().'[value]" value="'.$this->getValue().'" />';
	}
	/**
	 * get the file url
	 * @access protected
	 * @return string
	 * {{qwertyuiop}}
	 */
	protected function _getUrl(){
		return $this->getValue();
	}
	/**
	 * get the name
	 * @access public
	 * @return string
	 * {{qwertyuiop}}
	 */
	public function getName(){
		return $this->getData('name');
	}
}